Public Class frmAssistant


#Region "Evenements logiciels"

    'Si on ferme cette fentre => quitter l'application
    Private Sub frmAssistant_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        End
    End Sub

    'Lors de la premire apparition du formulaire
    Private Sub frmAssistant_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

        'On choisit les lments affichs par dfaut
        cbMatriau.SelectedIndex = 1
        cbCLHaut.SelectedIndex = 0
        cbCLBas.SelectedIndex = 0
        cbCLGauche.SelectedIndex = 0
        cbCLDroite.SelectedIndex = 0

        'On donne le focus au bouton "OK"
        btnOK.Focus()

    End Sub

#End Region


#Region "Action de l'utilisateur sur l'interface"

    'Modification du matriau
    Private Sub cbMatriau_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbMatriau.SelectedIndexChanged

        'Rend inactif les TextBox contenant les paramtres du matriau
        txtDiffusivit.Enabled = False
        txtConductivit.Enabled = False

        'Dtermine le caractre utilis comme sparateur dcimal (point ou virgule)
        Dim SparateurDcimal As String = My.Application.Culture.NumberFormat.NumberDecimalSeparator

        'Modifie les valeurs numriques
        Select Case cbMatriau.SelectedItem.ToString
            Case "Air"
                txtDiffusivit.Text = "0" & SparateurDcimal & "0000187"
                txtConductivit.Text = "0" & SparateurDcimal & "023"
            Case "Aluminium"
                txtDiffusivit.Text = "0" & SparateurDcimal & "000083"
                txtConductivit.Text = "200"
            Case "Argent"
                txtDiffusivit.Text = "0" & SparateurDcimal & "000173"
                txtConductivit.Text = "418"
            Case "Cuivre"
                txtDiffusivit.Text = "0" & SparateurDcimal & "000113"
                txtConductivit.Text = "389"
            Case "Diamant"
                txtDiffusivit.Text = "0" & SparateurDcimal & "001"
                txtConductivit.Text = "1980"
            Case "Eau"
                txtDiffusivit.Text = "0" & SparateurDcimal & "00000114"
                txtConductivit.Text = "0" & SparateurDcimal & "585"
            Case "Or"
                txtDiffusivit.Text = "0" & SparateurDcimal & "00013"
                txtConductivit.Text = "317"
            Case "Personnalis..."
                'Si un matriau personnalis est slectionn, rend actif les TextBox pour que l'utilisateur entre manuellement les valeurs
                txtDiffusivit.Enabled = True
                txtConductivit.Enabled = True
        End Select

    End Sub

    'Modification d'un type de condition aux limites
    Private Sub cbCLGauche_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbCLGauche.SelectedIndexChanged
        Select Case cbCLGauche.SelectedItem.ToString
            Case "Temprature fixe"
                lblParamGauche.Text = "T ="
                lblUnitGauche.Text = "C"
                lblParamGauche.Visible = True
                lblUnitGauche.Visible = True
                txtParamGauche.Visible = True
            Case Else
                lblParamGauche.Visible = False
                lblUnitGauche.Visible = False
                txtParamGauche.Visible = False
        End Select
    End Sub

    Private Sub cbCLDroite_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbCLDroite.SelectedIndexChanged
        Select Case cbCLDroite.SelectedItem.ToString
            Case "Temprature fixe"
                lblParamDroite.Text = "T ="
                lblUnitDroite.Text = "C"
                lblParamDroite.Visible = True
                lblUnitDroite.Visible = True
                txtParamDroite.Visible = True
            Case Else
                lblParamDroite.Visible = False
                lblUnitDroite.Visible = False
                txtParamDroite.Visible = False
        End Select
    End Sub

    Private Sub cbCLHaut_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbCLHaut.SelectedIndexChanged
        Select Case cbCLHaut.SelectedItem.ToString
            Case "Temprature fixe"
                lblParamHaut.Text = "T ="
                lblUnitHaut.Text = "C"
                lblParamHaut.Visible = True
                lblUnitHaut.Visible = True
                txtParamHaut.Visible = True
            Case Else
                lblParamHaut.Visible = False
                lblUnitHaut.Visible = False
                txtParamHaut.Visible = False
        End Select
    End Sub

    Private Sub cbCLBas_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbCLBas.SelectedIndexChanged
        Select Case cbCLBas.SelectedItem.ToString
            Case "Temprature fixe"
                lblParamBas.Text = "T ="
                lblUnitBas.Text = "C"
                lblParamBas.Visible = True
                lblUnitBas.Visible = True
                txtParamBas.Visible = True
            Case Else
                lblParamBas.Visible = False
                lblUnitBas.Visible = False
                txtParamBas.Visible = False
        End Select
    End Sub

    'Modification d'un paramtre physique => mise  jour du pas temporel
    Private Sub Paramtre_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDiffusivit.TextChanged, txtPasSpatial.TextChanged
        If Me.Visible = True Then
            Try
                Dim PasTemporel As Double = frmPrincipale.Sim.InitialiserPasTemporelMaxi(CDbl(txtPasSpatial.Text), CDbl(txtDiffusivit.Text))
                lblPasTemporel.Text = "Pas temporel = " & Math.Round(PasTemporel, 3).ToString & "s"
            Catch ex As Exception
            End Try
        End If
    End Sub

    'Modification d'une valeur numrique dans un TextBox
    Private Sub TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPasSpatial.TextChanged, txtParamBas.TextChanged, txtParamDroite.TextChanged, txtParamGauche.TextChanged, txtParamHaut.TextChanged, txtDiffusivit.TextChanged, txtConductivit.TextChanged

        'Affiche le TextBox en rouge si la valeur entre n'est pas un nombre
        If IsNumeric(sender.text) = False Then
            sender.backcolor = Color.LightCoral
        Else
            sender.backcolor = Color.White
        End If

    End Sub

#End Region


#Region "Clic sur un bouton"

    'Clic sur le bouton OK
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click


        '##### Reporte les valeurs dans la fentre principale #####
        With frmPrincipale
            .txtK.Text = txtDiffusivit.Text
            .txtPasSpatial.Text = txtPasSpatial.Text
            .txtNbrePas.Text = nudPas.Text
            .txtNbrePas2.Text = nudPas.Text

            Dim PasTemporel As Double = .Sim.InitialiserPasTemporelMaxi(CDbl(txtPasSpatial.Text), CDbl(txtDiffusivit.Text))
            .txtPasTemporel.Text = PasTemporel.ToString
        End With

        frmParamtres.txtLambda.Text = txtConductivit.Text
        frmParamtres.txtLambda2.Text = txtConductivit.Text





        '##### Si prsence de flux impos, demande de remplir les paramtres #####
        If cbCLGauche.SelectedItem.ToString = "Flux fix" Or cbCLDroite.SelectedItem.ToString = "Flux fix" Or cbCLHaut.SelectedItem.ToString = "Flux fix" Or cbCLBas.SelectedItem.ToString = "Flux fix" Then
            With frmParamtres
                .TabControl.SelectTab(1)
                .panelConductivit.Enabled = False
                .panelConductivit2.Enabled = False

                .ShowDialog()

                .panelConductivit.Enabled = True
                .panelConductivit2.Enabled = True
            End With

            frmPrincipale.Sim.Lambda = CDbl(frmParamtres.txtLambda.Text)
            frmPrincipale.Sim.CLFluxImpos = CDbl(frmParamtres.txtPhi.Text)
        End If

        '##### Si prsence de flux conducto-convectif, demande de remplir les paramtres #####
        If cbCLGauche.SelectedItem.ToString = "Flux conducto-convectif" Or cbCLDroite.SelectedItem.ToString = "Flux conducto-convectif" Or cbCLHaut.SelectedItem.ToString = "Flux conducto-convectif" Or cbCLBas.SelectedItem.ToString = "Flux conducto-convectif" Then
            With frmParamtres
                .TabControl.SelectTab(2)
                .panelConductivit.Enabled = False
                .panelConductivit2.Enabled = False

                .ShowDialog()

                .panelConductivit.Enabled = True
                .panelConductivit2.Enabled = True
            End With

            frmPrincipale.Sim.Lambda = CDbl(frmParamtres.txtLambda.Text)
            frmPrincipale.Sim.CLFluxCondConvh = CDbl(frmParamtres.txth.Text)
            frmPrincipale.Sim.CLFluxCondConvText = CDbl(frmParamtres.txtText.Text)
        End If





        '#### Dtermine les tempratures extrmes ####
        Dim TempMini As Double
        Dim TempMaxi As Double

        '----------
        DeterminerTemperaturesExtremes(TempMini, TempMaxi)

        'Reporte les tempratures extrmes dans la fentre principale
        frmPrincipale.txtTempMini.Text = TempMini.ToString
        frmPrincipale.txtTempMaxi.Text = TempMaxi.ToString



       

        '##### Cr les 2 images #####
        Dim Largeur As Integer = CInt(nudLargeur.Value)
        Dim Hauteur As Integer = CInt(nudHauteur.Value)

        Dim ImageCI As New Bitmap(Largeur, Hauteur)
        Dim ImageCL As Bitmap


        '##### Complte l'image des conditions initiales #####
        Dim gr As Graphics = Graphics.FromImage(ImageCI)
        'Efface le Bitmap et le remplit avec la couleur correspondant  la temprature initiale
        gr.Clear(Color.FromArgb(CInt(255 * (CDbl(txtTempInit.Text) - TempMini) / (TempMaxi - TempMini)), 0, 0))


        '##### Complte l'image des conditions aux limites #####
        '----------
        ImageCL = CompleterImageCL(Largeur, Hauteur, TempMini, TempMaxi)



        'Transmet les images  la fentre principale
        frmPrincipale.ImageCI = ImageCI
        frmPrincipale.ImageCL = ImageCL

        frmPrincipale.lblCI.Text = "Gnre par l'assistant"
        frmPrincipale.lblCL.Text = "Gnre par l'assistant"


        'Affiche la fentre principale avec les options simplifies
        frmPrincipale.PanelOptionsSimplifies.Visible = True
        frmPrincipale.PanelOptions.Visible = False

        'Cache l'assistant
        Me.Hide()

        'Montre la fentre principale
        frmPrincipale.Show()
        frmPrincipale.Size = New Size(CInt(frmPrincipale.PanelOptions.Width * 1.06), CInt((frmPrincipale.PanelOptionsSimplifies.Height + frmPrincipale.PanelResultats.Height) * 1.64))
        frmPrincipale.Refresh()

        'Lance le calcul
        frmPrincipale.btnLancer_Click(Nothing, Nothing)

    End Sub

#End Region


#Region "Procdures locales"

    'Dtermine les tempratures extrmes
    'ATTENTION : modification directe des paramtres (passs ByRef)
    Sub DeterminerTemperaturesExtremes(ByRef TempMini As Double, ByRef TempMaxi As Double)

        'Dfinit une liste de tempratures
        Dim ListTemp As New List(Of Double)

        'Ajoute les tempratures fixes des conditions aux limites
        ListTemp.Add(CDbl(txtTempInit.Text))
        If cbCLGauche.SelectedItem.ToString = "Temprature fixe" Then
            ListTemp.Add(CDbl(txtParamGauche.Text))
        End If
        If cbCLDroite.SelectedItem.ToString = "Temprature fixe" Then
            ListTemp.Add(CDbl(txtParamDroite.Text))
        End If
        If cbCLHaut.SelectedItem.ToString = "Temprature fixe" Then
            ListTemp.Add(CDbl(txtParamHaut.Text))
        End If
        If cbCLBas.SelectedItem.ToString = "Temprature fixe" Then
            ListTemp.Add(CDbl(txtParamBas.Text))
        End If

        '##### Si prsence de temprature variable, demande de remplir les paramtres #####
        If cbCLGauche.SelectedItem.ToString = "Temprature variable" Or cbCLDroite.SelectedItem.ToString = "Temprature variable" Or cbCLHaut.SelectedItem.ToString = "Temprature variable" Or cbCLBas.SelectedItem.ToString = "Temprature variable" Then
            frmParamtres.ShowDialog()
            ListTemp.Add(CDbl(frmParamtres.txtA.Text) - CDbl(frmParamtres.txtB.Text))
            ListTemp.Add(CDbl(frmParamtres.txtA.Text) + CDbl(frmParamtres.txtB.Text))
        End If

        ListTemp.Add(CDbl(frmParamtres.txtText.Text))

        'Trie les tempratures dans l'ordre croissant
        ListTemp.Sort()

        'Modifie les valeurs TempMini et TempMaxi
        TempMini = ListTemp(0)
        TempMaxi = ListTemp(ListTemp.Count - 1)

        'Si les valeurs mini et maxi sont gales :
        If TempMini = TempMaxi Then TempMaxi += 100

    End Sub

    'Retourne un Bitmap complt avec les conditions aux limites
    Function CompleterImageCL(ByVal Largeur As Integer, ByVal Hauteur As Integer, ByVal TempMini As Double, ByVal TempMaxi As Double) As Bitmap

        'Cr le bitmap des conditions aux limites
        Dim ImageCL As New Bitmap(Largeur, Hauteur)
        'Efface le Bitmap en blanc
        Dim Graph As Graphics = Graphics.FromImage(ImageCL)
        Graph.Clear(Color.White)

        'Bord Gauche
        Select Case cbCLGauche.SelectedItem.ToString
            Case "Temprature fixe"
                Dim T As Double = CDbl(txtParamGauche.Text)
                Dim Couleur As Color = Color.FromArgb(CInt(255 * (T - TempMini) / (TempMaxi - TempMini)), 0, 0)
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(0, i, Couleur)
                Next i
            Case "Temprature variable"
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(0, i, Color.Yellow)
                Next i
            Case "Paroi adiabatique"
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(0, i, Color.Blue)
                Next i
            Case "Flux conducto-convectif"
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(0, i, Color.Gray)
                Next i
            Case "Flux fix"
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(0, i, Color.Lime)
                Next i
        End Select

        'Bord Droit
        Select Case cbCLDroite.SelectedItem.ToString
            Case "Temprature fixe"
                Dim T As Double = CDbl(txtParamDroite.Text)
                Dim Couleur As Color = Color.FromArgb(CInt(255 * (T - TempMini) / (TempMaxi - TempMini)), 0, 0)
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(Largeur - 1, i, Couleur)
                Next i
            Case "Temprature variable"
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(Largeur - 1, i, Color.Yellow)
                Next i
            Case "Paroi adiabatique"
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(Largeur - 1, i, Color.Blue)
                Next i
            Case "Flux conducto-convectif"
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(Largeur - 1, i, Color.Gray)
                Next i
            Case "Flux fix"
                For i As Integer = 0 To Hauteur - 1
                    ImageCL.SetPixel(Largeur - 1, i, Color.Lime)
                Next i
        End Select

        'Bord Haut
        Select Case cbCLHaut.SelectedItem.ToString
            Case "Temprature fixe"
                Dim T As Double = CDbl(txtParamHaut.Text)
                Dim Couleur As Color = Color.FromArgb(CInt(255 * (T - TempMini) / (TempMaxi - TempMini)), 0, 0)
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, 0, Couleur)
                Next i
            Case "Temprature variable"
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, 0, Color.Yellow)
                Next i
            Case "Paroi adiabatique"
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, 0, Color.Blue)
                Next i
            Case "Flux conducto-convectif"
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, 0, Color.Gray)
                Next i
            Case "Flux fix"
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, 0, Color.Lime)
                Next i
        End Select

        'Bord Bas
        Select Case cbCLBas.SelectedItem.ToString
            Case "Temprature fixe"
                Dim T As Double = CDbl(txtParamBas.Text)
                Dim Couleur As Color = Color.FromArgb(CInt(255 * (T - TempMini) / (TempMaxi - TempMini)), 0, 0)
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, Hauteur - 1, Couleur)
                Next i
            Case "Temprature variable"
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, Hauteur - 1, Color.Yellow)
                Next i
            Case "Paroi adiabatique"
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, Hauteur - 1, Color.Blue)
                Next i
            Case "Flux conducto-convectif"
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, Hauteur - 1, Color.Gray)
                Next i
            Case "Flux fix"
                For i As Integer = 0 To Largeur - 1
                    ImageCL.SetPixel(i, Hauteur - 1, Color.Lime)
                Next i
        End Select

        'Retourne le bitmap
        Return ImageCL

    End Function

#End Region


End Class