Public Class frmGraph

#Region "Evnements"
    'Au dmarrage du formulaire
    Private Sub frmGraph_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'Complte le TextBox avec le nombre de pas effectus
        txtPas.Text = frmPrincipale.Sim.NombreDePasEffectus.ToString
    End Sub

    'Modification d'une valeur numrique dans un TextBox  (indique si une valeur incorrecte est entre)
    Private Sub TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPointX.TextChanged, txtPointY.TextChanged, txtPas.TextChanged, txtPosition.TextChanged
        If sender.Focused = False Then Exit Sub

        If IsNumeric(sender.Text) = False Then
            sender.BackColor = Color.LightCoral
        Else
            sender.BackColor = Color.White
        End If

    End Sub

    'Avance d'un pas l'animation
    Private Sub TimerJouer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerJouer.Tick

        'Incrmente le pas
        txtPas.Text = (CInt(txtPas.Text) + CInt(txtIncrement.Text)).ToString

        'Si on arrive  la fin
        If CInt(txtPas.Text) > frmPrincipale.Sim.NombreDePasEffectus Then
            TimerJouer.Enabled = False
            btnAnimation.Text = "Rejouer"
            txtPas.Text = (CInt(txtPas.Text) - CInt(txtIncrement.Text)).ToString
            Exit Sub
        End If

        'Si on n'est pas  la fin : affiche la coupe des tempratures
        btnAfficherCoupe_Click(Nothing, Nothing)

    End Sub

#End Region


#Region "Clic sur un bouton"
    'Affiche l'historique d'un point
    Private Sub btnAfficherTempPoint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAfficherPoint.Click
        'Dfinit le zoom (auto ou personnalis)
        ListPlot1._ZoomAutoX = radioRangeAuto.Checked
        ListPlot1._ZoomAutoY = radioRangeAuto.Checked

        'Dfinit le zoom (inutile si zoom auto est slectionn...)
        ListPlot1._ZoomXmin = 0
        ListPlot1._ZoomXmax = frmPrincipale.Sim.NombreDePasEffectus * frmPrincipale.Sim.PasTemporel
        ListPlot1._ZoomYmin = frmPrincipale.Sim.TempratureMini
        ListPlot1._ZoomYmax = frmPrincipale.Sim.TempratureMaxi

        'Dfinit le titre des axes
        ListPlot1._XAxisLabelText = "Temps (s)"
        ListPlot1._YAxisLabelText = "Temprature (C)"

        'Cr la liste du temps en abscisse
        Dim ListeTemps(frmPrincipale.Sim.NombreDePasEffectus) As Double
        For i As Integer = 0 To frmPrincipale.Sim.NombreDePasEffectus
            ListeTemps(i) = i * frmPrincipale.Sim.PasTemporel
        Next i

        'Affiche la courbe
        ListPlot1._Clear(False)
        ListPlot1._AddCurve(ListeTemps, frmPrincipale.Sim.ObtenirHistoriqueTemprature(CInt(txtPointX.Text), CInt(txtPointY.Text)))
    End Sub

    'Affiche la coupe de tempratures
    Private Sub btnAfficherCoupe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAfficherCoupe.Click
        'Dfinit le zoom (auto ou personnalis)
        ListPlot1._ZoomAutoX = radioRangeAuto.Checked
        ListPlot1._ZoomAutoY = radioRangeAuto.Checked

        'Dfinit le zoom (inutile si zoom auto est slectionn...)
        ListPlot1._ZoomXmin = 0
        ListPlot1._ZoomXmax = frmPrincipale.Sim.Taille.Width
        ListPlot1._ZoomYmin = frmPrincipale.Sim.TempratureMini
        ListPlot1._ZoomYmax = frmPrincipale.Sim.TempratureMaxi

        'Dfinit le titre des axes
        ListPlot1._XAxisLabelText = "Position"
        ListPlot1._YAxisLabelText = "Temprature (C)"


        'Si c'est une coupe horizontale
        If radioCoupeHoriz.Checked = True Then
            'Tableau qui contient le champ de tempratures au pas spcifi
            Dim Temp(,) As Double = frmPrincipale.Sim.ObtenirTableau(CInt(txtPas.Text))
            'Tableau qui contient la coupe de tempratures
            Dim TableauCoupe(Temp.GetUpperBound(0)) As Double

            'Remplit le tableau
            For i As Integer = 0 To Temp.GetUpperBound(0)
                If Temp(i, CInt(txtPosition.Text)) > -5000 Then
                    TableauCoupe(i) = Temp(i, CInt(txtPosition.Text))
                Else
                    'Si pixel adiabatique, alors Temprature = TemperatureMini
                    TableauCoupe(i) = frmPrincipale.Sim.TempratureMini
                End If
            Next i

            'Affiche la courbe
            ListPlot1._Clear(False)
            ListPlot1._AddCurve(TableauCoupe)
        End If


        'Si c'est une coupe verticale : idem mais dans l'autre sens...
        If radioCoupeVert.Checked = True Then
            Dim Temp(,) As Double = frmPrincipale.Sim.ObtenirTableau(CInt(txtPas.Text))
            Dim TableauCoupe(Temp.GetUpperBound(1)) As Double

            For i As Integer = 0 To Temp.GetUpperBound(1)
                If Temp(CInt(txtPosition.Text), i) > -5000 Then
                    TableauCoupe(i) = Temp(CInt(txtPosition.Text), i)
                Else
                    TableauCoupe(i) = frmPrincipale.Sim.TempratureMini
                End If
            Next i

            ListPlot1._Clear(False)
            ListPlot1._AddCurve(TableauCoupe)
        End If

    End Sub

    'Dmarre ou arrte l'animation
    Private Sub btnAnimation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnimation.Click

        'Si l'animation est en cours : on l'arrte
        If TimerJouer.Enabled = True Then
            TimerJouer.Enabled = False
            btnAnimation.Text = "Rejouer"
        Else
            'Sinon on la lance
            txtPas.Text = "0"
            TimerJouer.Enabled = True
            btnAnimation.Text = "Stop"
            'Et on affiche directement le 1er pas
            btnAfficherCoupe_Click(Nothing, Nothing)
        End If

    End Sub

#End Region

End Class