Imports System.Math


Public Class frmPrincipale


#Region "Variables publiques"
    'Composant fournissant la rsolution de l'quation de la chaleur
    Public Sim As New SimulationDiffusionThermique2D

    'Pas en train d'tre affich
    Public PasEnCours As Integer

    'Bitmaps contenant les conditions initiales et aux limites
    Public ImageCI As Bitmap
    Public ImageCL As Bitmap

#End Region


#Region "Evenements logiciels"

    'Au chargement de la fentre principale
    Private Sub frmPrincipale_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        'Dfinit les paramtres physiques
        Sim.PasSpatial = CDbl(txtPasSpatial.Text)
        Sim.PasTemporel = CDbl(txtPasTemporel.Text)
        Sim.K = CDbl(txtK.Text)

        'Redimensionne la fentre en fonction de la taille des Panel (pour Vista car a dconne)
        Me.Size = New Size(CInt(PanelOptions.Width * 1.06), CInt((PanelOptions.Height + PanelResultats.Height) * 1.35))

    End Sub


    'Lorsque la fentre principale est affiche pour la premire fois
    Private Sub frmPrincipale_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

        'Donne le focus au bouton "Lancer le calcul"
        btnLancer.Focus()

    End Sub

    'A la fermeture de la fentre principale
    Private Sub frmPrincipale_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        End
    End Sub


    'Evnement TimerJouer
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerJouer.Tick

        'Si l'incrment n'est pas un nombre
        If IsNumeric(txtIncrementPas.Text) = False Then Exit Sub

        'Affiche le pas en cours et le temps coul
        lblPas.Text = "Pas = " & PasEnCours.ToString
        lblTemps.Text = "t = " & Round(PasEnCours * Sim.PasTemporel, 1).ToString & " s"

        'Affiche l'image des tempratures correspondant au pas en cours dans la Form frmResultat
        Dim Gr As Graphics
        Dim Image As New Bitmap(frmRsultat.DisplayRectangle.Width, frmRsultat.DisplayRectangle.Height)
        Gr = Graphics.FromImage(Image)
        Gr.SmoothingMode = Drawing2D.SmoothingMode.HighSpeed
        Gr.PixelOffsetMode = Drawing2D.PixelOffsetMode.Half

        If chkInterpolation.Checked = False Then
            Gr.InterpolationMode = Drawing2D.InterpolationMode.NearestNeighbor
        Else
            Gr.InterpolationMode = Drawing2D.InterpolationMode.Default
        End If

        Gr.DrawImage(Sim.ObtenirImage(PasEnCours), 0, 0, frmRsultat.DisplayRectangle.Width, frmRsultat.DisplayRectangle.Height)
        frmRsultat.BackgroundImage = Image

        Image = Nothing


        'Incrmente PasEnCours de la valeur contenue dans txtPas
        PasEnCours += CInt(txtIncrementPas.Text)

        'Si on arrive  la fin, on arrte la lecture
        If PasEnCours > CInt(txtNbrePas.Text) Then
            TimerJouer.Enabled = False
            btnRejouer.Text = "Rejouer"
        End If

    End Sub

    'Evnement TimerMemoire : rafrachissement de l'utilisation mmoire
    Private Sub TimerMemoire_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerMemoire.Tick

        'Force le Garbage Collector  rorganiser la mmoire
        GC.Collect()

        'Affiche la mmoire vive utilise par l'application
        lblMemoire.Text = Math.Round(Diagnostics.Process.GetCurrentProcess.PagedMemorySize64 / 1000000).ToString & " Mo"

    End Sub

#End Region


#Region "Clics sur un bouton"

    'Ouvre le bitmap des conditions initiales
    Private Sub btnCI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCI.Click
        If OpenFileDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                lblCI.Text = OpenFileDialog.FileName
                ImageCI = New Bitmap(OpenFileDialog.FileName)
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical)
            End Try

        End If
    End Sub

    'Ouvre le bitmap des conditions aux limites
    Private Sub btnCL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCL.Click
        If OpenFileDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                lblCL.Text = OpenFileDialog.FileName
                ImageCL = New Bitmap(OpenFileDialog.FileName)
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical)
            End Try
        End If
    End Sub


    'LANCE LE CALCUL
    Sub btnLancer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLancer.Click

        'Vrifie si les fichiers existent
        If lblCI.Text = "Aucun" Or lblCL.Text = "Aucun" Then
            MessageBox.Show("Slectionnez d'abord les fichiers image", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If

        btnRejouer.Enabled = True
        TimerJouer.Enabled = False

        'Cr un StopWatch pour mesurer le temps de calcul
        Dim sw As New Stopwatch
        sw.Start()



        'Initialise le composant avec les bitmaps choisis et les tempratures extrmes correspondantes
        Sim.Initialiser(ImageCI, ImageCL, CInt(txtTempMini.Text), CInt(txtTempMaxi.Text))


        'Ici : on effectue un nombre de pas dfinis
        If radioNbrePas.Checked = True Then
            For i As Integer = 1 To CInt(txtNbrePas.Text)
                'On modifie la temprature instantane des zones "conditions aux limites variables"
                Sim.CLTempratureVariable = (CInt(frmParamtres.txtA.Text) + CInt(frmParamtres.txtB.Text) * Cos(2 * PI * i * Sim.PasTemporel / CInt(frmParamtres.txtT.Text)) + CInt(frmParamtres.txtX.Text))
                'On avance le calcul d'un pas
                Sim.AvancerUnPas()
            Next
        End If

        'Ici : on effectue le calcul tant que la prcision (diffrence maxi de temprature entre les deux derniers pas) est suprieure  un seuil donn
        If radioPrecision.Checked = True Then
            Dim i As Integer = 1
            Do
                Sim.CLTempratureVariable = (CInt(frmParamtres.txtA.Text) + CInt(frmParamtres.txtB.Text) * Cos(2 * PI * i * Sim.PasTemporel / CInt(frmParamtres.txtT.Text)) + CInt(frmParamtres.txtX.Text))
                Sim.AvancerUnPas()
                i += 1
            Loop Until Sim.Prcision < CDbl(txtPrecision.Text) Or i > 5000
            'Place le nombre de pas dans le TextBox txtNbrePas
            txtNbrePas.Text = Sim.NombreDePasEffectus.ToString
        End If



        'Arrte le chronomtrage
        sw.Stop()
        'Affiche le temps de calcul
        Label7.Text = "Temps de calcul = " & sw.ElapsedMilliseconds.ToString & " ms"



        'Redimensionne et affiche la Form frmResultat
        frmRsultat.Size = New Size(Sim.Taille.Width * 6, Sim.Taille.Height * 6)
        frmRsultat.Show()


        'Active la lecture du rsultat (cd l'affichage des tempratures pour les instants successifs)
        PasEnCours = 0
        TimerJouer.Enabled = True
        btnRejouer.Text = "Stop"

    End Sub

    'Rejoue ou arrte le rsultat du calcul
    Private Sub btnRejouer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRejouer.Click

        If TimerJouer.Enabled = True Then
            'Si la lecture est en cours : on arrte
            TimerJouer.Enabled = False
            btnRejouer.Text = "Rejouer"
        Else
            'Si la lecture est arrte :

            'On affiche la fentre frmRsultat
            If frmRsultat.Visible = False Then frmRsultat.Size = New Size(Sim.Taille.Width * 6, Sim.Taille.Height * 6)
            frmRsultat.Show()
            PasEnCours = 0

            'et on lance la lecture
            TimerJouer.Enabled = True
            btnRejouer.Text = "Stop"
        End If

    End Sub

    'Lance la fentre du grapheur
    Private Sub btnCourbes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCourbes.Click
        frmGraph.Show()
    End Sub

    'Lance la fentre des paramtres
    Private Sub btnParamtres_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnParamtres.Click
        frmParamtres.Show()
    End Sub

#End Region


#Region "Action de l'utilisateur sur l'interface"

    'Modification des paramtres physiques
    Private Sub txtParamPhysiques_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtK.TextChanged, txtPasSpatial.TextChanged, txtPasTemporel.TextChanged
        If sender.Focused = False Then Exit Sub


        If IsNumeric(sender.Text) Then
            'Affiche le TextBox en blanc si le contenu est un nombre
            sender.BackColor = Color.White

            'Redfinit les paramtres de la simulation
            Sim.PasSpatial = CDbl(txtPasSpatial.Text)
            Sim.PasTemporel = CDbl(txtPasTemporel.Text)
            Sim.K = CDbl(txtK.Text)
        Else
            'Affiche le TextBox en rouge si le contenu n'est pas un nombre
            sender.BackColor = Color.LightCoral
            Exit Sub
        End If

        'Affiche si la solution est convergente
        If Sim.SolutionConvergente = True Then
            lblSolutionConvergente.Text = "Solution convergente"
        Else
            lblSolutionConvergente.Text = "SOLUTION NON CONVERGENTE"
        End If

    End Sub

    'Modification d'une valeur numrique dans un TextBox
    Private Sub txtTempExtreme_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtNbrePas.TextChanged, txtIncrementPas.TextChanged, txtPrecision.TextChanged, txtTempMaxi.TextChanged, txtTempMini.TextChanged, txtNbrePas2.TextChanged
        If sender.Focused = False Then Exit Sub

        'Affiche le TextBox en rouge si la valeur entre n'est pas un nombre
        If IsNumeric(sender.text) = False Then
            sender.backcolor = Color.LightCoral
        Else
            sender.BackColor = Color.White
        End If

    End Sub

    'Changement d'un bouton radio
    Private Sub RadioButton_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioNbrePas.CheckedChanged, radioPrecision.CheckedChanged
        If radioPrecision.Checked = True Then txtPrecision.Enabled = True Else txtPrecision.Enabled = False
        If radioNbrePas.Checked = True Then txtNbrePas.Enabled = True Else txtNbrePas.Enabled = False
    End Sub

#End Region


#Region "Gestion des options simplifies"

    'Clic sur le bouton "Plus d'options"
    Private Sub btnPlusOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlusOptions.Click

        'Agrandit la fentre principale
        For i As Integer = 372 To CInt((PanelOptions.Height + PanelResultats.Height) * 1.34) Step 2
            Me.Size = New Size(CInt(PanelOptions.Width * 1.055), i)
            Attente(1)
        Next

        'Masque les options simplifies et affiche les options standard
        PanelOptionsSimplifies.Visible = False
        PanelOptions.Visible = True

    End Sub

    'Clic sur le bouton "Relancer le calcul"
    Private Sub btnLancer2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLancer2.Click
        'Relance le calcul en utilisant les options standard
        txtNbrePas.Text = txtNbrePas2.Text
        btnLancer_Click(Nothing, Nothing)
    End Sub

    'Sous-programme permettant d'attendre un nombre donn de millisacondes
    Private Sub Attente(ByVal Millisecondes As Integer)
        Dim SW As New Stopwatch
        SW.Start()
        Do
            Application.DoEvents()
        Loop Until SW.ElapsedMilliseconds >= Millisecondes
    End Sub

#End Region


End Class
