Public Class frmRsultat

    'Quand on ferme cette fentre
    Private Sub frmResultat_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        'On arrte l'animation
        frmPrincipale.TimerJouer.Enabled = False
        frmPrincipale.btnRejouer.Text = "Rejouer"
    End Sub

    'Lors d'un clic droit sur l'image
    Private Sub frmResultat_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        'On affiche le menu contextuel
        If e.Button = Windows.Forms.MouseButtons.Right Then
            ContextMenuStrip.Show(Me, e.Location)
        End If
    End Sub

    'Enregistre l'image au format BMP ou JPEG
    Private Sub EnregistrerLimageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnregistrerLimageToolStripMenuItem.Click
        'Masque la fentre d'affichage du rsultat (elle est TopMost=True et cela est gnant avec la bote de dialogue)
        Me.Hide()

        'Dtermine le pas en cours
        Dim PasImage As Integer = CInt(frmPrincipale.lblPas.Text.Substring(6))


        'Enregistrement au format JPEG ou BMP
        SaveFileDialog.Filter = "Image Bitmap (*.bmp)|*.bmp|Image JPEG (*.jpg)|*.jpg"
        SaveFileDialog.FileName = "Rsultat (Pas " & PasImage.ToString & ")"

        'Affiche la bote de dialogue
        If SaveFileDialog.ShowDialog() = Windows.Forms.DialogResult.Cancel Then Exit Sub


        'Rcupre le format d'enregistrement
        Dim Format As String = SaveFileDialog.FileName.Substring(SaveFileDialog.FileName.Length - 3)

        If Format = "jpg" Then
            '####### Extrait de l'aide MSDN => permet de choisir le taux de compression du JPEG #######
            Try
                Dim myBitmap As Bitmap
                Dim myImageCodecInfo As Imaging.ImageCodecInfo
                Dim myEncoder As Imaging.Encoder
                Dim myEncoderParameter As Imaging.EncoderParameter
                Dim myEncoderParameters As Imaging.EncoderParameters

                ' Create a Bitmap object based on a BMP file.
                myBitmap = frmPrincipale.Sim.ObtenirImage(PasImage)

                ' Get an ImageCodecInfo object that represents the JPEG codec.
                myImageCodecInfo = GetEncoderInfo("image/jpeg")

                ' Create an Encoder object based on the GUID
                ' for the Quality parameter category.
                myEncoder = Imaging.Encoder.Quality

                ' Create an EncoderParameters object.
                ' An EncoderParameters object has an array of EncoderParameter
                ' objects. In this case, there is only one
                ' EncoderParameter object in the array.
                myEncoderParameters = New Imaging.EncoderParameters(1)

                ' Save the bitmap as a JPEG file with quality level 100.
                myEncoderParameter = New Imaging.EncoderParameter(myEncoder, 100)
                myEncoderParameters.Param(0) = myEncoderParameter
                myBitmap.Save(SaveFileDialog.FileName, myImageCodecInfo, myEncoderParameters)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error) : Exit Sub
            End Try

        End If

        If Format = "bmp" Then
            'Enregistre l'image
            Try
                frmPrincipale.Sim.ObtenirImage(PasImage).Save(SaveFileDialog.FileName, Imaging.ImageFormat.Bmp)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error) : Exit Sub
            End Try
        End If

    End Sub

    'Fonction ncessaire  l'enregistrement JPEG (extrait de l'aide MSDN)
    Private Function GetEncoderInfo(ByVal mimeType As String) As Imaging.ImageCodecInfo
        Dim j As Integer
        Dim encoders() As Imaging.ImageCodecInfo
        encoders = Imaging.ImageCodecInfo.GetImageEncoders()

        j = 0
        While j < encoders.Length
            If encoders(j).MimeType = mimeType Then
                Return encoders(j)
            End If
            j += 1
        End While
        Return Nothing

    End Function

    'Affiche la temprature sous la souris dans une info-bulle
    Private Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerToolTip.Tick

        'Si la souris est positionne au dessus de la fentre frmRsultat
        If Me.ClientRectangle.Contains(PointToClient(Control.MousePosition)) = True And ContextMenuStrip.Visible = False Then
            'On affiche la temprature dans l'info-bulle
            Try
                Dim T As Double = Math.Round(frmPrincipale.Sim.ObtenirTemprature(frmPrincipale.PasEnCours, CInt(PointToClient(Control.MousePosition).X * frmPrincipale.Sim.Taille.Width / Me.DisplayRectangle.Width), CInt(PointToClient(Control.MousePosition).Y * frmPrincipale.Sim.Taille.Height / Me.DisplayRectangle.Height)), 2)
                Dim TString As String = T.ToString
                Select Case T
                    Case SimulationDiffusionThermique2D.ConstanteCL.CLAdiabatique
                        ToolTip.SetToolTip(Me, "Adiabatique")
                    Case SimulationDiffusionThermique2D.ConstanteCL.CLFluxImpos
                        ToolTip.SetToolTip(Me, "Flux impos")
                    Case SimulationDiffusionThermique2D.ConstanteCL.CLFluxCondConv
                        ToolTip.SetToolTip(Me, "Flux conducto-convectif")
                    Case Else
                        ToolTip.SetToolTip(Me, "T = " & TString & "C")
                End Select
            Catch ex As Exception
            End Try

        End If

    End Sub

End Class